<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Control Flow</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Control Flow</h1>    
                    </section>
                    <section>
                        <h2>Control Flow Overview</h2>
                        <ul>
                            <li>Statements & Blocks</li>
                            <li>Conditional Statements</li>
                            <li>Loops</li>
                            <li>Nested Control Flow</li>
                        </ul>
                    </section>
                    <section>
                        <h2><a href=../objectives.html>Objectives</a></h2>
                    </section>
                </section>
                <!-- Statements and Blocks Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">   
                    <section>
                        <h2>Statements and Blocks</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
						<h2>Statements</h2>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
printf("Hello, World!\n"); // This is a statement)
						</span></code></pre>
						<p>and...</p>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
if(something){
	do (something);
}
						</span></code></pre>

						<aside class="notes">
							Statements are snippets of code that do things. They are human readable text that a compiler will turn into executable statements when compiled.
						</aside>
					</section>

					<section>
                        <h2>Blocks</h2>
                        
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
if (something)
{
	if (somethingElse)
	{
		do something;
	}
}
else if (something1)
{
	do something;
}
else
{
	do nothing;
}</code></pre></div></div>
						<aside class="notes">
							A block is a group of executable statements.
						</aside>
                    </section>
                    
                </section>
                <!-- If Statements Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>if Statements</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>If Statements</h2>
                        <ul>
                            <li>Create conditional jumps</li>
                            <li>Tests an expression as TRUE or FALSE</li>
                            <li>When a condition is TRUE, the code block is run</li>
                        </ul>
                    </section>
                    <section>
                        <h2>If Statement Syntax</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">if (condition)         
{
    // Statements to execute if condition is true
}</code></pre></div></div>
                    </section>
                    <section>
                        <h2>Examples</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">if (1 > 0)               //example 1
{
    printf("All is alright with the world. \n");
}

if (1)                  //example 2
{
    printf("1 evaluates to TRUE. \n");
}

if (i  > u)  		 //example 3
{
    printf("i is greater than u. (pun_intended = FALSE) \n");
}

if (i && i == u)         //example 4
{
    printf("apparently, this works and i evaluates to TRUE. \n");
}</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Demonstration Lab</h2>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>
                <!-- if/else Statments Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>if/else Statements</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Else Syntax</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">if (condition)
{
    // Statements to execute if condition is true
}
else
{
    // Statements to execute if condition is false
}	</code></pre></div></div>
                    </section>
                    <section>
                        <h2>Else example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">if (i >= u)
{
    printf("u is no greater than i. \n");
}
else
{
    printf("u is greater than i. \n");
}	</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Labs</h2>
                </section>
                <!-- else/if Statements Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>else/if Statements</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Else if syntax</h2>
                        <p>You can use else if to check a new condition after the first is FALSE</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">if (condition1)
{
     // Statements to execute if condition1 is true
}
else if (condition2)
{
     // Statements to execute if condition is false and condition2 is true
}
else
{
    // Statements to execute if both condition1 and condition2 are false
}</code></pre></div></div>
                    </section>
                    <section>
                        <h2>Else if example</h2>
                        <p>You can use else if to check a new condition after the first is FALSE</p>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">if (i > u)
{
    printf("I is greater than u. \n");
}
else if (i < u)
{
    printf("u is greater than i. \n");
}
else
{
    printf("u and i are equal. \n");
}</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Labs</h2>
                </section>

                <!-- switch Statements Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Switch Statements</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Switch Statements:</h2>
                        <ul>
                            <li>Make Conditional Jumps</li>
                            <li>Tests an expression against cases</li>
                            <li>If a case is true, it will execute until a break</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Switch Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">switch (binaryInput)
{
    case 1:
            printf("%d = TRUE \n", binaryInput);
            break;
    case 0:
            printf("%d = FALSE \n", binaryInput);
            break;
    default:
            printf("something has gone wrong! \n");
            break;
}</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Labs</h2>
                </section>

                <!-- Loops Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Loops</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Loops</h2>
                        <ul>
                            <li>Repeats a block of code</li>
                            <li>Three main types: For, While and Do While</li>
                        </ul>
                    </section>
                    <section>
                        <h3>"Three or more? Use a for!"</h3>
                    </section>
                    <section>
                        <h2>For Loop Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">int i = 0;

for (i = 0; i < 15; i++)
{
    printf("i = %d\n", i + 1);
}</code></pre></div></div>
                    </section>

                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                        <h2>Performance Lab</h2>
                    </section>



                    <section>
                        <h2>Questions</h2>
                        <ul>
                            <li>What previous labs could have benefited from a FOR loop?</li>
                            <li>Were there arrays to manipulate?</li>
                            <li>Were there repetitious calculations?</li>
                            <li>Were there places where code was copy pasta?</li>
                        </ul>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>

                <!-- while Loops Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>while Loops</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>While Loops:</h2>
                        <ul>
                            <li>Run code while a certain condition is true</li>
                            <li>Checks the condition every iteration</li>
                            <li>Take care to avoid infinite loops</li>
                        </ul>
                    </section>
                    <section>
                        <h2>While Loop Syntax</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">while (testExpression)
{
    //block of code statements
}</code></pre></div></div>
                    </section>
                    <section>
                        <h2>While Loop Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">int i = 512;
int counter = 0;

while (i != 0)
{		// …execute this
    // Print i
    printf(“i = %d\n”, i);
    // (i /= 2) == (i = i / 2)
    i /= 2;
    counter++; // 1 run counted
    // Is i still != 0?
}</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>

                <!-- do while Loops Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>do while Loops</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>

                    <section>
                        <h2>Do While Loops:</h2>
                        <ul>
                            <li>Work very similarly to while loops</li>
                            <li>Runs the code first, then checks condition</li>
                            <li>Take care to avoid infinite loops</li>
                        </ul>
                    </section>
                    <section>
                        <h2>Do While Loop Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">int i = 0;
char myString [] = "Shadow Warriors"
do		
// Execute this…
{
// Print one array element
    printf(“%c\n”, myString[i]);
// Increment the counter
    i++;
}
// Is myString[i] != the null terminator?
while(myString[i] != '\0');</code></pre></div></div>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>

                <!-- Break Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Break & Continue</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Break</h2>
                        <ul>
                            <li>Useful with an if statement for exiting a loop when a condition is met</li>
                            <li>Exits the innermost loop (or case statement)</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Continue</h2>
                        <ul>
                            <li>Returns to the top of the loop</li>
                            <li>Useful for skipping input</li>
                        </ul>
                    </section>
                    <section>
                        <h2>Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">int i = 0;               //iterating variable
int firstNumber = 0;    //numerator
int secondNumber = 0;   //denominator

for(i = 0; i < 10; i++) //loops 10 times
{
    printf("x %% y \n");    //prints necessary format
    _flushall();            //clears all open streams
    scanf("%d %% %d", &frstNumber, &secondNumber);
    if (secondNumber == 0)  //checks for "divide by 0"
    {
        continue;           //skips "divide by 0"
    }
    printf("result: %2f \n", (float)firstNumber / secondNumber);
}</code></pre></div></div>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Demonstration Lab</h2>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>

                <!-- Nested Control Flow Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Nested Control Flow</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Nested Control Flow</h2>
                        <ul>
                            <li>Conditional statements are often nested inside loops</li>
                            <li>Loops are often nested inside conditional statements</li>
                        </ul>
                    </section>
                    <section>
                        <h2>Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">for (i = 1; i <= 4; i++)
{
    //print the 1st level
    printf("%d. \n", i);
/* second for loop iterates through the 2nd level, [A-C] */
    for(j = 'A', j < 'D'; j++)
    {
        //print the 2nd level
        printf("\t%c. \n". j);
    }
}</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">while(i<=n)
    {
       j=1;
       while(j<=n-i)
       {
          printf(" ");
          j++;
       }
       j=1;
       while(j<=2*i-1)
       {
          printf("*");
          j++;
       }
       i++;
       printf("\n");
    }
    printf("\n");
}</code></pre></div></div>
                    </section>

                </section>
 
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <h2>Performance Lab</h2>
                </section>
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>Statements & Blocks</li>
                            <li>Conditional Statements</li>
                            <li>Loops</li>
                            <li>Nested Control Flow</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
